"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretedGenomeRD(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "InterpretationRequestID",
        "analysisId",
        "companyName",
        "reportURI",
        "reportURL",
        "reportedVariants",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "reportedStructuralVariants": reports_2_1_0.ReportedStructuralVariant,
            "reportedVariants": reports_2_1_0.ReportedVariant,
            "versionControl": reports_2_1_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.ReportedStructuralVariant": reports_2_1_0.ReportedStructuralVariant,
            "Gel_BioInf_Models.ReportedVariant": reports_2_1_0.ReportedVariant,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.InterpretedGenomeRD": reports_2_1_0.InterpretedGenomeRD,
        }

    __slots__ = [
        "InterpretationRequestID",
        "analysisId",
        "companyName",
        "reportURI",
        "reportURL",
        "reportedVariants",
        "versionControl",
        "comments",
        "reportedStructuralVariants",
    ]

    def __init__(
        self,
        InterpretationRequestID,
        analysisId,
        companyName,
        reportURI,
        reportURL,
        reportedVariants,
        versionControl,
        comments=None,
        reportedStructuralVariants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.InterpretedGenomeRD model.

        :param InterpretationRequestID:
            This is the ID of the clinical interpretation request
        :type InterpretationRequestID: str
        :param analysisId:
            This is the ID of the analysis carried out and is expected to be
            linked to the conditions and parameters     used to
            produce the clinical interpretation over this group of
            samples. It is critical to establish provenance.     It is
            expected that this id can be used to retrieve an analysis
            in the decision support/ variant exploration tools
        :type analysisId: str
        :param companyName:
            Name of the company
        :type companyName: str
        :param reportURI:
            URI in the GEL file system where the company has upload files from
            this analysis
        :type reportURI: str
        :param reportURL:
            URL where the results can be accessed in the company's web interface
        :type reportURL: str
        :param reportedVariants:
            List of all reported variants
        :type reportedVariants: list[ReportedVariant]
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        :param reportedStructuralVariants:
            List of all reported structural variants
        :type reportedStructuralVariants: None | list[ReportedStructuralVariant]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
